Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 2696)
@@ -1057,118 +1830,30 @@
           IF ( .NOT. bc_lr_cyc )  THEN
              IF ( nxl == 0  )  THEN
-                nzb_local(:,-1)   = nzb_local(:,0)
-                nzb_local(:,-2)   = nzb_local(:,0)
-                nzb_local(:,-3)   = nzb_local(:,0)
-             ELSEIF ( nxr == nx )  THEN
-                nzb_local(:,nx+1) = nzb_local(:,nx)
-                nzb_local(:,nx+2) = nzb_local(:,nx)          
-                nzb_local(:,nx+3) = nzb_local(:,nx)          
-             ENDIF          
+                DO  i = 1, nbgp 
+                   topo(:,:,nxl-i) = topo(:,:,nxl)
+                ENDDO
+             ENDIF
+             IF ( nxr == nx )  THEN
+                DO  i = 1, nbgp 
+                   topo(:,:,nxr+i) = topo(:,:,nxr)
+                ENDDO
+             ENDIF
           ENDIF
 
-          num_hole_l = 0
-          DO i = nxl, nxr
-             DO j = nys, nyn
-
-                num_wall = 0
-
-                IF ( nzb_local(j-1,i) > nzb_local(j,i) )                       &
-                   num_wall = num_wall + 1
-                IF ( nzb_local(j+1,i) > nzb_local(j,i) )                       &
-                   num_wall = num_wall + 1
-                IF ( nzb_local(j,i-1) > nzb_local(j,i) )                       &
-                   num_wall = num_wall + 1
-                IF ( nzb_local(j,i+1) > nzb_local(j,i) )                       &
-                   num_wall = num_wall + 1
-
-                IF ( num_wall == 4 )  THEN
-                   nzb_local(j,i) = MIN( nzb_local(j-1,i), nzb_local(j+1,i),   &
-                                         nzb_local(j,i-1), nzb_local(j,i+1) )
-                   num_hole_l     = num_hole_l + 1
-                ENDIF
-             ENDDO
-          ENDDO
-!
-!--       Count the total number of holes, required for informative message.
-#if defined( __parallel )
-          CALL MPI_ALLREDUCE( num_hole_l, num_hole, 1, MPI_INTEGER, MPI_SUM,   &
-                              comm2d, ierr )
-#else
-          num_hole = num_hole_l
-#endif    
-!
-!--       Create an informative message if any hole was removed.
-          IF ( num_hole > 0 )  THEN
-             WRITE( message_string, * ) num_hole, 'hole(s) resolved by only '//&
-                                                  'one grid point were filled'
-             CALL message( 'init_grid', 'PA0430', 0, 0, 0, 6, 0 )
-          ENDIF
-
-!
-!--       Set bit array to mask topography. Only required for lod = 1
-          IF ( lod == 1 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   topo_3d(nzb_local(j,i)+1:nzt+1,j,i) =                          &
-                                 IBSET( topo_3d(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
-                ENDDO
-             ENDDO
-          ENDIF
-!
-!--       Exchange ghost-points, as well as add cyclic or Neumann boundary 
-!--       conditions.
-          CALL exchange_horiz_int( topo_3d, nbgp )
-          CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
-          
-          IF ( .NOT. bc_ns_cyc )  THEN
-             IF ( nys == 0  )  topo_3d(:,-1,:)   = topo_3d(:,0,:)
-             IF ( nyn == ny )  topo_3d(:,ny+1,:) = topo_3d(:,ny,:)
-
-             IF ( nys == 0  )  nzb_local(-1,:)   = nzb_local(0,:)
-             IF ( nyn == ny )  nzb_local(ny+1,:) = nzb_local(ny,:)
-          ENDIF
-
-          IF ( .NOT. bc_lr_cyc )  THEN
-             IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
-             IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)     
-
-             IF ( nxl == 0  )  nzb_local(:,-1)   = nzb_local(:,0)
-             IF ( nxr == nx )  nzb_local(:,nx+1) = nzb_local(:,nx)          
-          ENDIF
-
 
        CASE DEFAULT
-!
+!   
 !--       The DEFAULT case is reached either if the parameter topography
 !--       contains a wrong character string or if the user has defined a special
 !--       case in the user interface. There, the subroutine user_init_grid 
 !--       checks which of these two conditions applies.
-          CALL user_init_grid( topo_3d )
+          CALL user_init_grid( topo )
+          CALL filter_topography( topo )
 
     END SELECT
 !
 !-- Consistency checks and index array initialization are only required for
-!-- non-flat topography, also the initialization of topography height arrays
-!-- zu_s_inner and zw_w_inner
+!-- non-flat topography.
     IF ( TRIM( topography ) /= 'flat' )  THEN
-#if defined( __parallel )
-       CALL MPI_ALLREDUCE( MAXVAL( nzb_local ), nzb_local_max, 1, MPI_INTEGER, &
-                           MPI_MAX, comm2d, ierr )
-       CALL MPI_ALLREDUCE( MINVAL( nzb_local ), nzb_local_min, 1, MPI_INTEGER, &
-                           MPI_MIN, comm2d, ierr )                           
-#else
-       nzb_local_max = MAXVAL( nzb_local )
-       nzb_local_min = MINVAL( nzb_local )
-#endif
-
-!
-!--    Consistency checks
-       IF ( nzb_local_min < 0  .OR.  nzb_local_max  > nz + 1 )  THEN
-          WRITE( message_string, * ) 'nzb_local values are outside the',       &
-                                'model domain',                                &
-                                '&MINVAL( nzb_local ) = ', nzb_local_min,      &
-                                '&MAXVAL( nzb_local ) = ', nzb_local_max
-          CALL message( 'init_grid', 'PA0210', 1, 2, 0, 6, 0 )
-       ENDIF
 !
 !--    In case of non-flat topography, check whether the convention how to 
@@ -1184,9 +1869,9 @@
 !--          defined in init_grid.
              WRITE( message_string, * )                                        &
-                  'The value for "topography_grid_convention" ',               &
-                  'is not set. Its default value is & only valid for ',        &
-                  '"topography" = ''single_building'', ',                      &
-                  '''single_street_canyon'' & or ''read_from_file''.',         &
-                  ' & Choose ''cell_edge'' or ''cell_center''.'
+               'The value for "topography_grid_convention" ',                  &
+               'is not set. Its default value is & only valid for ',           &
+               '"topography" = ''single_building'', ',                         &
+               '''single_street_canyon'' & or ''read_from_file''.',            &
+               ' & Choose ''cell_edge'' or ''cell_center''.'
              CALL message( 'init_grid', 'PA0239', 1, 2, 0, 6, 0 )
           ELSE
@@ -1204,44 +1889,9 @@
                 TRIM( topography_grid_convention ) /= 'cell_center' )  THEN
           WRITE( message_string, * )                                           &
-               'The value for "topography_grid_convention" is ',               &
-               'not recognized. & Choose ''cell_edge'' or ''cell_center''.'
+            'The value for "topography_grid_convention" is ',                  &
+            'not recognized. & Choose ''cell_edge'' or ''cell_center''.'
           CALL message( 'init_grid', 'PA0240', 1, 2, 0, 6, 0 )
        ENDIF
 
-!
-!--    In case of non-flat topography, check whether the convention how to 
-!--    define the topography grid has been set correctly, or whether the default
-!--    is applicable. If this is not possible, abort.
-       IF ( TRIM( topography_grid_convention ) == ' ' )  THEN
-          IF ( TRIM( topography ) /= 'single_building' .AND.                   &
-               TRIM( topography ) /= 'single_street_canyon' .AND.              &
-               TRIM( topography ) /= 'read_from_file' )  THEN
-!--          The default value is not applicable here, because it is only valid
-!--          for the two standard cases 'single_building' and 'read_from_file'
-!--          defined in init_grid.
-             WRITE( message_string, * )                                        &
-                  'The value for "topography_grid_convention" ',               &
-                  'is not set. Its default value is & only valid for ',        &
-                  '"topography" = ''single_building'', ',                      &
-                  '''single_street_canyon'' & or ''read_from_file''.',         &
-                  ' & Choose ''cell_edge'' or ''cell_center''.'
-             CALL message( 'init_grid', 'PA0239', 1, 2, 0, 6, 0 )
-          ELSE
-!--          The default value is applicable here.
-!--          Set convention according to topography.
-             IF ( TRIM( topography ) == 'single_building' .OR.                 &
-                  TRIM( topography ) == 'single_street_canyon' )  THEN
-                topography_grid_convention = 'cell_edge'
-             ELSEIF ( TRIM( topography ) == 'read_from_file' )  THEN
-                topography_grid_convention = 'cell_center'
-             ENDIF
-          ENDIF
-       ELSEIF ( TRIM( topography_grid_convention ) /= 'cell_edge' .AND.        &
-                TRIM( topography_grid_convention ) /= 'cell_center' )  THEN
-          WRITE( message_string, * )                                           &
-               'The value for "topography_grid_convention" is ',               &
-               'not recognized. & Choose ''cell_edge'' or ''cell_center''.'
-          CALL message( 'init_grid', 'PA0240', 1, 2, 0, 6, 0 )
-       ENDIF
 
        IF ( topography_grid_convention == 'cell_edge' )  THEN
@@ -1259,269 +1909,80 @@
           DO  j = nys+1, nyn+1
              DO  i = nxl-1, nxr
-                nzb_local(j,i) = MIN( nzb_local(j,i), nzb_local(j,i+1) )
-             ENDDO
-          ENDDO
-!
-!--       Exchange ghost points
-          CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
-
-          DO  i = nxl, nxr+1
-             DO  j = nys-1, nyn
-                nzb_local(j,i) = MIN( nzb_local(j,i), nzb_local(j+1,i) )
-             ENDDO
-          ENDDO  
-!
-!--       Exchange ghost points          
-          CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
-!
-!--       Apply cell-edge convention also for 3D topo array. The former setting
-!--       of nzb_local will be removed later. 
-          DO  j = nys+1, nyn+1
-             DO  i = nxl-1, nxr
                 DO  k = nzb, nzt+1
-                   IF ( BTEST( topo_3d(k,j,i), 0 )  .OR.                       &
-                        BTEST( topo_3d(k,j,i+1), 0 ) )                         &
-                      topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                   IF ( BTEST( topo(k,j,i), 0 )  .OR.                          &
+                        BTEST( topo(k,j,i+1), 0 ) )                            &
+                       topo(k,j,i) = IBSET( topo(k,j,i), 0 )
                 ENDDO
              ENDDO
           ENDDO      
-          CALL exchange_horiz_int( topo_3d, nbgp )   
+          CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
 
           DO  i = nxl, nxr+1
              DO  j = nys-1, nyn
                 DO  k = nzb, nzt+1
-                   IF ( BTEST( topo_3d(k,j,i), 0 )  .OR.                       &
-                        BTEST( topo_3d(k,j+1,i), 0 ) )                         &
-                      topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                   IF ( BTEST( topo(k,j,i), 0 )  .OR.                          &
+                        BTEST( topo(k,j+1,i), 0 ) )                            &
+                      topo(k,j,i) = IBSET( topo(k,j,i), 0 )
                 ENDDO
              ENDDO
           ENDDO  
-          CALL exchange_horiz_int( topo_3d, nbgp )
+          CALL exchange_horiz_int( topo, nys, nyn, nxl, nxr, nzt, nbgp )
    
        ENDIF
-      
-!
-!--    Initialize index arrays nzb_s_inner and nzb_w_inner
-
-       nzb_s_inner = nzb_local
-       nzb_w_inner = nzb_local
-
-!
-!--    Initialize remaining index arrays:
-!--    first pre-initialize them with nzb_s_inner...
-       nzb_u_inner = nzb_s_inner
-       nzb_u_outer = nzb_s_inner
-       nzb_v_inner = nzb_s_inner
-       nzb_v_outer = nzb_s_inner
-       nzb_w_outer = nzb_s_inner
-       nzb_s_outer = nzb_s_inner
-
-!
-!--    ...then extend pre-initialized arrays in their according directions
-!--    based on nzb_local using nzb_tmp as a temporary global index array
-
-!
-!--    nzb_s_outer: 
-!--    extend nzb_local east-/westwards first, then north-/southwards
-       nzb_tmp = nzb_local
-       DO  j = nys, nyn
-          DO  i = nxl, nxr
-             nzb_tmp(j,i) = MAX( nzb_local(j,i-1), nzb_local(j,i),             &
-                                 nzb_local(j,i+1) )
-          ENDDO
-       ENDDO
-       
-       CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )
-       
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             nzb_s_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i),             &
-                                     nzb_tmp(j+1,i) )
-          ENDDO
-!
-!--       non-cyclic boundary conditions (overwritten by call of
-!--       exchange_horiz_2d_int below in case of cyclic boundary conditions)
-          IF ( nys == 0 )  THEN
-             j = -1
-             nzb_s_outer(j,i) = MAX( nzb_tmp(j+1,i), nzb_tmp(j,i) )
-          ENDIF
-          IF ( nyn == ny )  THEN
-             j = ny + 1
-             nzb_s_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i) )
-          ENDIF
-       ENDDO
-!
-!--    nzb_w_outer: 
-!--    identical to nzb_s_outer
-       nzb_w_outer = nzb_s_outer
-
-!
-!--    nzb_u_inner: 
-!--    extend nzb_local rightwards only
-       nzb_tmp = nzb_local
-       DO  j = nys, nyn
-          DO  i = nxl, nxr
-             nzb_tmp(j,i) = MAX( nzb_local(j,i-1), nzb_local(j,i) )
-          ENDDO
-       ENDDO
-       
-       CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )
-       
-       nzb_u_inner = nzb_tmp
-!
-!--    nzb_u_outer: 
-!--    extend current nzb_tmp (nzb_u_inner) north-/southwards
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             nzb_u_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i),             &
-                                     nzb_tmp(j+1,i) )
-          ENDDO
-!
-!--       non-cyclic boundary conditions (overwritten by call of
-!--       exchange_horiz_2d_int below in case of cyclic boundary conditions)
-          IF ( nys == 0 )  THEN
-             j = -1
-             nzb_u_outer(j,i) = MAX( nzb_tmp(j+1,i), nzb_tmp(j,i) )
-          ENDIF
-          IF ( nyn == ny )  THEN
-             j = ny + 1
-             nzb_u_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i) )
-          ENDIF
-       ENDDO
-
-!
-!--    nzb_v_inner:
-!--    extend nzb_local northwards only
-       nzb_tmp = nzb_local
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             nzb_tmp(j,i) = MAX( nzb_local(j-1,i), nzb_local(j,i) )
-          ENDDO
-       ENDDO
-       
-       CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )      
-       nzb_v_inner = nzb_tmp
-
-!
-!--    nzb_v_outer: 
-!--    extend current nzb_tmp (nzb_v_inner) right-/leftwards
-       DO  j = nys, nyn
-          DO  i = nxl, nxr
-             nzb_v_outer(j,i) = MAX( nzb_tmp(j,i-1), nzb_tmp(j,i),             &
-                                     nzb_tmp(j,i+1) )
-          ENDDO
-!
-!--       non-cyclic boundary conditions (overwritten by call of
-!--       exchange_horiz_2d_int below in case of cyclic boundary conditions)
-          IF ( nxl == 0 )  THEN
-             i = -1
-             nzb_v_outer(j,i) = MAX( nzb_tmp(j,i+1), nzb_tmp(j,i) )
-          ENDIF
-          IF ( nxr == nx )  THEN
-             i = nx + 1
-             nzb_v_outer(j,i) = MAX( nzb_tmp(j,i-1), nzb_tmp(j,i) )
-          ENDIF
-       ENDDO
-
-!
-!--    Exchange of lateral boundary values (parallel computers) and cyclic
-!--    boundary conditions, if applicable.
-!--    Since nzb_s_inner and nzb_w_inner are derived directly from nzb_local
-!--    they do not require exchange and are not included here.
-       CALL exchange_horiz_2d_int( nzb_u_inner, nys, nyn, nxl, nxr, nbgp )
-       CALL exchange_horiz_2d_int( nzb_u_outer, nys, nyn, nxl, nxr, nbgp )
-       CALL exchange_horiz_2d_int( nzb_v_inner, nys, nyn, nxl, nxr, nbgp )
-       CALL exchange_horiz_2d_int( nzb_v_outer, nys, nyn, nxl, nxr, nbgp )
-       CALL exchange_horiz_2d_int( nzb_w_outer, nys, nyn, nxl, nxr, nbgp )
-       CALL exchange_horiz_2d_int( nzb_s_outer, nys, nyn, nxl, nxr, nbgp )
-
     ENDIF
-!
-!-- Deallocate temporary array, as it might be reused for different
-!-- grid-levels further below.
-    DEALLOCATE( nzb_tmp )
-
-!
-!-- Determine the maximum level of topography. It is used for
-!-- steering the degradation of order of the applied advection scheme.
-!-- In case of non-cyclic lateral boundaries, the order of the advection
-!-- scheme has to be reduced up to nzt (required at the lateral boundaries).
-    k_top = 0
+
+
+ END SUBROUTINE init_topo
+
+ SUBROUTINE set_topo_flags(topo)
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, constant_flux_layer, land_surface,        &
+               use_surface_fluxes, use_top_fluxes, urban_surface
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
+               nzb, nzt, wall_flags_0
+
+    USE kinds
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i             !< index variable along x
+    INTEGER(iwp) ::  j             !< index variable along y
+    INTEGER(iwp) ::  k             !< index variable along z
+
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo !< input array for 3D topography and dummy array for setting "outer"-flags
+
+    ALLOCATE( wall_flags_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    wall_flags_0 = 0
+!
+!-- Set-up topography flags. First, set flags only for s, u, v and w-grid.
+!-- Further special flags will be set in following loops. 
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          DO  k = nzb, nzt + 1
-             k_top = MAX( k_top, MERGE( k, 0,                                  &
-                                        .NOT. BTEST( topo_3d(k,j,i), 0 ) ) )
+          DO  k = nzb, nzt+1
+!
+!--          scalar grid
+             IF ( BTEST( topo(k,j,i), 0 ) )                                 &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
+!
+!--          u grid
+             IF ( BTEST( topo(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo(k,j,i-1), 0 ) )                               &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
+!
+!--          v grid
+             IF ( BTEST( topo(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo(k,j-1,i), 0 ) )                               &
+                 wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 2 )
+
           ENDDO
-       ENDDO
-    ENDDO
-#if defined( __parallel )
-    CALL MPI_ALLREDUCE( k_top + 1, nzb_max, 1, MPI_INTEGER,                    & !is +1 really necessary here?
-                        MPI_MAX, comm2d, ierr )
-#else
-    nzb_max = k_top + 1
-#endif
-    IF ( inflow_l .OR. outflow_l .OR. inflow_r .OR. outflow_r .OR.             &
-         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s .OR.             &
-         nest_domain )                                                         &
-    THEN
-       nzb_max = nzt
-    ENDIF
-!
-!-- Finally, if topography extents up to the model top, limit nzb_max to nzt.
-    nzb_max = MIN( nzb_max, nzt ) 
-
-!
-!-- Set the individual index arrays which define the k index from which on
-!-- the usual finite difference form (which does not use surface fluxes) is
-!-- applied 
-    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-       nzb_diff_s_inner   = nzb_s_inner + 2
-       nzb_diff_s_outer   = nzb_s_outer + 2
-    ELSE
-       nzb_diff_s_inner   = nzb_s_inner + 1
-       nzb_diff_s_outer   = nzb_s_outer + 1
-    ENDIF
-
-!
-!-- Set-up topography flags. First, set flags only for s, u, v and w-grid.
-!-- Further special flags will be set in following loops. 
-    wall_flags_0 = 0
-    DO  j = nys, nyn
-       DO  i = nxl, nxr
-          DO  k = nzb, nzt+1
-!
-!--          scalar grid
-             IF ( BTEST( topo_3d(k,j,i), 0 ) )                                 &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
-!
-!--          v grid
-             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
-                  BTEST( topo_3d(k,j-1,i), 0 ) )                               &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 2 )
-!
-!--     To do: set outer arrays on basis of topo_3d array, adjust for downward-facing walls
-!--          s grid outer array
-             IF ( k >= nzb_s_outer(j,i) )                                      &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 24 )
-!
-!--          s grid outer array
-             IF ( k >= nzb_u_outer(j,i) )                                      &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 26 )
-!
-!--          s grid outer array
-             IF ( k >= nzb_v_outer(j,i) )                                      &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
-!
-!--          w grid outer array
-             IF ( k >= nzb_w_outer(j,i) )                                      &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
-          ENDDO
 
           DO k = nzb, nzt
 !
 !--          w grid
-             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
-                  BTEST( topo_3d(k+1,j,i), 0 ) )                               &
+             IF ( BTEST( topo(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo(k+1,j,i), 0 ) )                               &
                 wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
           ENDDO
@@ -1530,13 +1991,20 @@
        ENDDO
     ENDDO
-!
-!-- u grid. Note, reverse 
-!-- memory access is required for setting flag on u-grid
-    DO  j = nys, nyn
-       DO  i = nxl, nxr
+
+    CALL exchange_horiz_int ( wall_flags_0, nys, nyn, nxl, nxr, nzt, nbgp )
+!
+!-- Set outer array for scalars to mask near-surface grid points in 
+!-- production_e
+    DO i = nxl, nxr
+       DO j = nys, nyn
           DO k = nzb, nzt+1
-             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
-                  BTEST( topo_3d(k,j,i-1), 0 ) )                               &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
+             IF ( BTEST( wall_flags_0(k,j-1,i), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j+1,i), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j,i-1), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j-1,i-1), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j+1,i-1), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j-1,i+1), 0 )  .AND.                       &
+                  BTEST( wall_flags_0(k,j+1,i+1), 0 ) )                            &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 24 )
           ENDDO
        ENDDO
@@ -1576,4 +2044,5 @@
              wall_flags_0(nzt+1,j,i) = IBCLR( wall_flags_0(nzt+1,j,i), 9 )
 
+
           DO k = nzb+1, nzt
 !
@@ -1634,5 +2103,5 @@
              IF ( BTEST( wall_flags_0(k-1,j,i), 0 )  .AND.                     &
             .NOT. BTEST( wall_flags_0(k,j,i), 0   ) )                          & 
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 ) 
+                 wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 ) 
 !
 !--          Downward facing wall on u grid
@@ -1665,10 +2134,10 @@
                 wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 14 )
 
-!
+!   
 !--          Upward facing wall on v grid
              IF ( .NOT. BTEST( wall_flags_0(k,j,i),   2 )  .AND.               &
                         BTEST( wall_flags_0(k+1,j,i), 2 ) )                    & 
                 wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 16 )
-
+   
 !
 !--          Upward facing wall on w grid
@@ -1681,5 +2150,5 @@
                   BTEST( wall_flags_0(k,j,i), 12 ) .OR.                        &
                   BTEST( wall_flags_0(k,j,i), 13 ) )                           &
-                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
 !
 !--          Special flag on scalar grid, nzb_diff_s_inner - 1, required for 
@@ -1688,10 +2157,10 @@
                 IF ( BTEST( wall_flags_0(k,j,i),   0 )  .AND.                  &
                      BTEST( wall_flags_0(k+1,j,i), 0 ) )                       &
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
+                  wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
              ELSE
                 IF ( BTEST( wall_flags_0(k,j,i), 22 ) )                        &
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
              ENDIF
-
+   
 
           ENDDO
